class Split < ActiveRecord::Base
 set_table_name "splits"
 belongs_to :account, :foreign_key => "account_guid"
 belongs_to :transaction, :foreign_key => "tx_guid"
 has_many :rec_account, :class_name => "Split", :foreign_key => "tx_guid", :primary_key => "tx_guid"
 self.primary_key = "guid"
 def self.yearly_per_type(my_type)
  #   sum(:value_num, :joins => [:transaction,:account], :group => "date_part('year',date_posted), type", :having => "account_type not in ('EQUITY', 'CASH')", :order => "date_part('year',date_posted), type")
   sum(:value_num, :joins => [:transaction,:account], :conditions => ["account_type = ?", my_type], :group => "date_part('year', (timezone('UTC', post_date)))", :order => "date_part('year', (timezone('UTC', post_date)))")
 end
def self.yearly_per_name(my_name)
  #   sum(:value_num, :joins => [:transaction,:account], :group => "date_part('year',date_posted), type", :having => "account_type not in ('EQUITY', 'CASH')", :order => "date_part('year',date_posted), type")
   sum(:value_num, :joins => [:transaction,:account], :conditions => ["name = ?", my_name], :group => "date_part('year', (timezone('UTC', post_date)))", :order => "date_part('year', (timezone('UTC', post_date)))")
 end
  def self.monthly_by_type_and_year(my_type, my_year)
   sum(:value_num, :joins => [:transaction,:account], :conditions => ["account_type = ? and date_part('year', (timezone('UTC', post_date)))= ?", my_type, my_year], :group => "date_part('month', (timezone('UTC', post_date)))", :order => "date_part('month', (timezone('UTC', post_date)))")
 end
  def self.account_monthly_by_year(my_account, my_year)
   sum(:value_num, :joins => [:transaction,:account], :conditions => ["account_guid = ? and date_part('year', (timezone('UTC', post_date)))= ?", my_account, my_year], :group => "date_part('month', (timezone('UTC', post_date)))", :order => "date_part('month', (timezone('UTC', post_date)))")
 end
 def self.account_yearly_by_type_and_year(my_type, my_year)
   sum(:value_num, :joins => [:transaction,:account], :conditions => ["account_type = ? and date_part('year', (timezone('UTC', post_date)))= ?", my_type, my_year], :group => " name", :having => "sum(value_num) <> 0", :order => "name")
 end
 def self.savingplan_yearly(from_account, to_account, save_value)
   sum(:value_num, :joins => [:rec_account, :transaction], :conditions => ["splits.account_guid = ? and rec_accounts_splits.account_guid= ? and (abs(splits.value_num) - ? <= 0)", from_account, to_account, save_value], :group => " date_part('year', (timezone('UTC', post_date)))", :order => "date_part('year', (timezone('UTC', post_date)))")
 end
  def self.savingsplan_monthly(from_account, to_account, my_year, save_value)
   sum(:value_num, :joins => [:rec_account, :transaction], :conditions => ["splits.account_guid = ? and rec_accounts_splits.account_guid= ? and date_part('year', (timezone('UTC', post_date)))=? and (abs(splits.value_num) - ?  <= 0)", from_account, to_account, my_year, save_value], :group => " date_part('month', (timezone('UTC', post_date)))", :order => "date_part('month', (timezone('UTC', post_date)))")
 end
 def self.tx_list(ac_guid, year)
   find(:all, :joins => [:transaction,:account],:conditions => ["splits.account_guid = ? and date_part('year', (timezone('UTC', post_date)))= ?", ac_guid, year], :order => "post_date")
 end
 def self.tx_list_monthly(ac_guid, year, month)
   find(:all, :joins => [:transaction,:account],:conditions => ["splits.account_guid = ? and date_part('year', (timezone('UTC', post_date)))= ? and date_part('month', (timezone('UTC', post_date)))=?", ac_guid, year, month], :order => "post_date")
 end
 def self.parentguid_by_type_and_year(my_type, my_year)
   sum(:value_num, :joins => [:transaction,:account], :conditions => ["account_type = ? and date_part('year', (timezone('UTC', post_date)))= ?", my_type, my_year], :group => "parent_guid", :order => "parent_guid")
 end
 def self.yearly_per_name_and_desc(my_guid, my_desc)
    the_desc = '%' + my_desc +'%'
    sum(:value_num, :joins => [:transaction,:account], :conditions => ["account_guid = ? and transactions.description like ?", my_guid, the_desc], :group => "date_part('year', (timezone('UTC', post_date)))", :order => "date_part('year', (timezone('UTC', post_date)))")
 end
 def self.yearly_per_name_and_2desc(my_guid, my_desc1, my_desc2)
    the_desc1 = '%' + my_desc1 +'%'
    the_desc2 = '%' + my_desc2 +'%'
    sum(:value_num, :joins => [:transaction,:account], :conditions => ["account_guid = ? and (transactions.description like ? or transactions.description like ?)", my_guid, the_desc1, the_desc2], :group => "date_part('year', (timezone('UTC', post_date)))", :order => "date_part('year', (timezone('UTC', post_date)))")
 end
end

