# This file is auto-generated from the current state of the database. Instead of editing this file, 
# please use the migrations feature of Active Record to incrementally modify your database, and
# then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your database schema. If you need
# to create the application database on another system, you should be using db:schema:load, not running
# all the migrations from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended to check this file into your version control system.

ActiveRecord::Schema.define(:version => 20100114212211) do

  create_table "accounts", :id => false, :force => true do |t|
    t.string  "guid",           :limit => 32,   :null => false
    t.string  "name",           :limit => 2048, :null => false
    t.string  "account_type",   :limit => 2048, :null => false
    t.string  "commodity_guid", :limit => 32
    t.integer "commodity_scu",                  :null => false
    t.integer "non_std_scu",                    :null => false
    t.string  "parent_guid",    :limit => 32
    t.string  "code",           :limit => 2048
    t.string  "description",    :limit => 2048
    t.integer "hidden"
    t.integer "placeholder"
  end

  create_table "billterms", :id => false, :force => true do |t|
    t.string  "guid",           :limit => 32,   :null => false
    t.string  "name",           :limit => 2048, :null => false
    t.string  "description",    :limit => 2048, :null => false
    t.integer "refcount",                       :null => false
    t.integer "invisible",                      :null => false
    t.string  "parent",         :limit => 32
    t.string  "child",          :limit => 32
    t.string  "type",           :limit => 2048, :null => false
    t.integer "duedays"
    t.integer "discountdays"
    t.integer "discount_num",   :limit => 8
    t.integer "discount_denom", :limit => 8
    t.integer "cutoff"
  end

  create_table "books", :id => false, :force => true do |t|
    t.string "guid",               :limit => 32, :null => false
    t.string "root_account_guid",  :limit => 32, :null => false
    t.string "root_template_guid", :limit => 32, :null => false
  end

  create_table "budget_amounts", :force => true do |t|
    t.string  "budget_guid",  :limit => 32, :null => false
    t.string  "account_guid", :limit => 32, :null => false
    t.integer "period_num",                 :null => false
    t.integer "amount_num",   :limit => 8,  :null => false
    t.integer "amount_denom", :limit => 8,  :null => false
  end

  create_table "budgets", :id => false, :force => true do |t|
    t.string  "guid",        :limit => 32,   :null => false
    t.string  "name",        :limit => 2048, :null => false
    t.string  "description", :limit => 2048
    t.integer "num_periods",                 :null => false
  end

  create_table "commodities", :id => false, :force => true do |t|
    t.string  "guid",         :limit => 32,   :null => false
    t.string  "namespace",    :limit => 2048, :null => false
    t.string  "mnemonic",     :limit => 2048, :null => false
    t.string  "fullname",     :limit => 2048
    t.string  "cusip",        :limit => 2048
    t.integer "fraction",                     :null => false
    t.integer "quote_flag",                   :null => false
    t.string  "quote_source", :limit => 2048
    t.string  "quote_tz",     :limit => 2048
  end

  create_table "customers", :force => true do |t|
    t.string  "guid",           :limit => 32,   :null => false
    t.string  "name",           :limit => 2048, :null => false
    t.string  "notes",          :limit => 2048, :null => false
    t.integer "active",                         :null => false
    t.integer "discount_num",   :limit => 8,    :null => false
    t.integer "discount_denom", :limit => 8,    :null => false
    t.integer "credit_num",     :limit => 8,    :null => false
    t.integer "credit_denom",   :limit => 8,    :null => false
    t.string  "currency",       :limit => 32,   :null => false
    t.integer "tax_override",                   :null => false
    t.string  "addr_name",      :limit => 1024
    t.string  "addr_addr1",     :limit => 1024
    t.string  "addr_addr2",     :limit => 1024
    t.string  "addr_addr3",     :limit => 1024
    t.string  "addr_addr4",     :limit => 1024
    t.string  "addr_phone",     :limit => 128
    t.string  "addr_fax",       :limit => 128
    t.string  "addr_email",     :limit => 256
    t.string  "shipaddr_name",  :limit => 1024
    t.string  "shipaddr_addr1", :limit => 1024
    t.string  "shipaddr_addr2", :limit => 1024
    t.string  "shipaddr_addr3", :limit => 1024
    t.string  "shipaddr_addr4", :limit => 1024
    t.string  "shipaddr_phone", :limit => 128
    t.string  "shipaddr_fax",   :limit => 128
    t.string  "shipaddr_email", :limit => 256
    t.string  "terms",          :limit => 32
    t.integer "tax_included"
    t.string  "taxtable",       :limit => 32
  end

  create_table "employees", :force => true do |t|
    t.string  "guid",          :limit => 32,   :null => false
    t.string  "username",      :limit => 2048, :null => false
    t.string  "language",      :limit => 2048, :null => false
    t.string  "acl",           :limit => 2048, :null => false
    t.integer "active",                        :null => false
    t.string  "currency",      :limit => 32,   :null => false
    t.string  "ccard_guid",    :limit => 32
    t.integer "workday_num",   :limit => 8,    :null => false
    t.integer "workday_denom", :limit => 8,    :null => false
    t.integer "rate_num",      :limit => 8,    :null => false
    t.integer "rate_denom",    :limit => 8,    :null => false
    t.string  "addr_name",     :limit => 1024
    t.string  "addr_addr1",    :limit => 1024
    t.string  "addr_addr2",    :limit => 1024
    t.string  "addr_addr3",    :limit => 1024
    t.string  "addr_addr4",    :limit => 1024
    t.string  "addr_phone",    :limit => 128
    t.string  "addr_fax",      :limit => 128
    t.string  "addr_email",    :limit => 256
  end

  create_table "entries", :id => false, :force => true do |t|
    t.string   "guid",             :limit => 32,   :null => false
    t.datetime "date",                             :null => false
    t.datetime "date_entered"
    t.string   "description",      :limit => 2048
    t.string   "action",           :limit => 2048
    t.string   "notes",            :limit => 2048
    t.integer  "quantity_num",     :limit => 8
    t.integer  "quantity_denom",   :limit => 8
    t.string   "i_acct",           :limit => 32
    t.integer  "i_price_num",      :limit => 8
    t.integer  "i_price_denom",    :limit => 8
    t.integer  "i_discount_num",   :limit => 8
    t.integer  "i_discount_denom", :limit => 8
    t.string   "invoice",          :limit => 32
    t.string   "i_disc_type",      :limit => 2048
    t.string   "i_disc_how",       :limit => 2048
    t.integer  "i_taxable"
    t.integer  "i_taxincluded"
    t.string   "i_taxtable",       :limit => 32
    t.string   "b_acct",           :limit => 32
    t.integer  "b_price_num",      :limit => 8
    t.integer  "b_price_denom",    :limit => 8
    t.string   "bill",             :limit => 32
    t.integer  "b_taxable"
    t.integer  "b_taxincluded"
    t.string   "b_taxtable",       :limit => 32
    t.integer  "b_paytype"
    t.integer  "billable"
    t.integer  "billto_type"
    t.string   "billto_guid",      :limit => 32
    t.string   "order_guid",       :limit => 32
  end

  create_table "invoices", :force => true do |t|
    t.string   "guid",             :limit => 32,   :null => false
    t.datetime "date_opened"
    t.datetime "date_posted"
    t.string   "notes",            :limit => 2048, :null => false
    t.integer  "active",                           :null => false
    t.string   "currency",         :limit => 32,   :null => false
    t.integer  "owner_type"
    t.string   "owner_guid",       :limit => 32
    t.string   "terms",            :limit => 32
    t.string   "billing_id",       :limit => 2048
    t.string   "post_txn",         :limit => 32
    t.string   "post_lot",         :limit => 32
    t.string   "post_acc",         :limit => 32
    t.integer  "billto_type"
    t.string   "billto_guid",      :limit => 32
    t.integer  "charge_amt_num",   :limit => 8
    t.integer  "charge_amt_denom", :limit => 8
  end

  create_table "jobs", :force => true do |t|
    t.string  "guid",       :limit => 32,   :null => false
    t.string  "name",       :limit => 2048, :null => false
    t.string  "reference",  :limit => 2048, :null => false
    t.integer "active",                     :null => false
    t.integer "owner_type"
    t.string  "owner_guid", :limit => 32
  end

  create_table "lots", :id => false, :force => true do |t|
    t.string  "guid",         :limit => 32, :null => false
    t.string  "account_guid", :limit => 32
    t.integer "is_closed",                  :null => false
  end

  create_table "orders", :force => true do |t|
    t.string   "guid",        :limit => 32,   :null => false
    t.string   "notes",       :limit => 2048, :null => false
    t.string   "reference",   :limit => 2048, :null => false
    t.integer  "active",                      :null => false
    t.datetime "date_opened",                 :null => false
    t.datetime "date_closed",                 :null => false
    t.integer  "owner_type",                  :null => false
    t.string   "owner_guid",  :limit => 32,   :null => false
  end

  create_table "prices", :id => false, :force => true do |t|
    t.string   "guid",           :limit => 32,   :null => false
    t.string   "commodity_guid", :limit => 32,   :null => false
    t.string   "currency_guid",  :limit => 32,   :null => false
    t.datetime "date",                           :null => false
    t.string   "source",         :limit => 2048
    t.string   "type",           :limit => 2048
    t.integer  "value_num",      :limit => 8,    :null => false
    t.integer  "value_denom",    :limit => 8,    :null => false
  end

  create_table "recurrences", :force => true do |t|
    t.string  "obj_guid",                :limit => 32,   :null => false
    t.integer "recurrence_mult",                         :null => false
    t.string  "recurrence_period_type",  :limit => 2048, :null => false
    t.date    "recurrence_period_start",                 :null => false
  end

  create_table "savingplans", :force => true do |t|
    t.string  "from_account", :limit => 32, :null => false
    t.string  "to_account",   :limit => 32, :null => false
    t.date    "start_date"
    t.date    "end_date"
    t.integer "value_num"
    t.integer "value_denom"
  end

  create_table "schedxactions", :id => false, :force => true do |t|
    t.string  "guid",              :limit => 32,   :null => false
    t.string  "name",              :limit => 2048
    t.integer "enabled",                           :null => false
    t.date    "start_date"
    t.date    "end_date"
    t.date    "last_occur"
    t.integer "num_occur",                         :null => false
    t.integer "rem_occur",                         :null => false
    t.integer "auto_create",                       :null => false
    t.integer "auto_notify",                       :null => false
    t.integer "adv_creation",                      :null => false
    t.integer "adv_notify",                        :null => false
    t.integer "instance_count",                    :null => false
    t.string  "template_act_guid", :limit => 32,   :null => false
  end

  create_table "slots", :force => true do |t|
    t.string   "obj_guid",          :limit => 32,   :null => false
    t.string   "name",              :limit => 4096, :null => false
    t.integer  "slot_type",                         :null => false
    t.integer  "int64_val",         :limit => 8
    t.string   "string_val",        :limit => 4096
    t.float    "double_val"
    t.datetime "timespec_val"
    t.string   "guid_val",          :limit => 32
    t.integer  "numeric_val_num",   :limit => 8
    t.integer  "numeric_val_denom", :limit => 8
  end

  add_index "slots", ["obj_guid"], :name => "slots_guid_index"

  create_table "splits", :id => false, :force => true do |t|
    t.string   "guid",            :limit => 32,   :null => false
    t.string   "tx_guid",         :limit => 32,   :null => false
    t.string   "account_guid",    :limit => 32,   :null => false
    t.string   "memo",            :limit => 2048, :null => false
    t.string   "action",          :limit => 2048, :null => false
    t.string   "reconcile_state", :limit => 1,    :null => false
    t.datetime "reconcile_date"
    t.integer  "value_num",       :limit => 8,    :null => false
    t.integer  "value_denom",     :limit => 8,    :null => false
    t.integer  "quantity_num",    :limit => 8,    :null => false
    t.integer  "quantity_denom",  :limit => 8,    :null => false
    t.string   "lot_guid",        :limit => 32
  end

  add_index "splits", ["tx_guid"], :name => "splits_tx_guid_index"

  create_table "taxtable_entries", :force => true do |t|
    t.string  "taxtable",     :limit => 32, :null => false
    t.string  "account",      :limit => 32, :null => false
    t.integer "amount_num",   :limit => 8,  :null => false
    t.integer "amount_denom", :limit => 8,  :null => false
    t.integer "type",                       :null => false
  end

  create_table "taxtables", :id => false, :force => true do |t|
    t.string  "guid",      :limit => 32, :null => false
    t.string  "name",      :limit => 50, :null => false
    t.integer "refcount",  :limit => 8,  :null => false
    t.integer "invisible",               :null => false
    t.string  "parent",    :limit => 32
  end

  create_table "transactions", :id => false, :force => true do |t|
    t.string   "guid",          :limit => 32,   :null => false
    t.string   "currency_guid", :limit => 32,   :null => false
    t.string   "num",           :limit => 2048, :null => false
    t.datetime "post_date"
    t.datetime "enter_date"
    t.string   "description",   :limit => 2048
    t.date     "postdate"
    t.integer  "postyear"
    t.integer  "postmonth"
  end

  create_table "users", :force => true do |t|
    t.string   "login",                     :limit => 40
    t.string   "name",                      :limit => 100, :default => ""
    t.string   "email",                     :limit => 100
    t.string   "crypted_password",          :limit => 40
    t.string   "salt",                      :limit => 40
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "remember_token",            :limit => 40
    t.datetime "remember_token_expires_at"
  end

  add_index "users", ["login"], :name => "index_users_on_login", :unique => true

  create_table "vendors", :force => true do |t|
    t.string  "guid",         :limit => 32,   :null => false
    t.string  "name",         :limit => 2048, :null => false
    t.string  "notes",        :limit => 2048, :null => false
    t.string  "currency",     :limit => 32,   :null => false
    t.integer "active",                       :null => false
    t.integer "tax_override",                 :null => false
    t.string  "addr_name",    :limit => 1024
    t.string  "addr_addr1",   :limit => 1024
    t.string  "addr_addr2",   :limit => 1024
    t.string  "addr_addr3",   :limit => 1024
    t.string  "addr_addr4",   :limit => 1024
    t.string  "addr_phone",   :limit => 128
    t.string  "addr_fax",     :limit => 128
    t.string  "addr_email",   :limit => 256
    t.string  "terms",        :limit => 32
    t.string  "tax_inc",      :limit => 2048
    t.string  "tax_table",    :limit => 32
  end

  create_table "versions", :id => false, :force => true do |t|
    t.string  "table_name",    :limit => 50, :null => false
    t.integer "table_version",               :null => false
  end

end
